#include <LiquidCrystal.h>
LiquidCrystal lcd(A2, A3, A4, A5,A6, A7);

#include <Keypad.h>

const byte ROWS = 4; //four rows
const byte COLS = 3; //three columns
char keys[ROWS][COLS] = {
  {'1','2','3'},
  {'4','5','6'},
  {'7','8','9'},
  {'*','0','#'}
};

byte rowPins[ROWS] = {8, 7, 6, 5}; //connect to the row pinouts of the keypad
byte colPins[COLS] = {4, 3, 2}; //connect to the column pinouts of the keypad

Keypad keypad = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );

int error;
int max_per;
int min_per;

long int num,a,b = 0,c;

long R1 = 100000; 
long Rd;

int P1 = A1;
int P2 = A0;

double I;

double  v_in1;
double  v_in2;

double v_out;

double V1;  //input volatge 1
double V2;  //input volatge 2

#include <Servo.h>

Servo M1;
Servo M2;
Servo M3;
Servo M4;

int led1 = 52;
int led2 = 53;
void setup(){
  
   Serial.begin(9600);
   lcd.begin(16, 2);

  M1.attach(9);
  M2.attach(10);  
  M3.attach(11);
  M4.attach(12);

    pinMode(P1,INPUT);
    pinMode(P2,INPUT);

    pinMode(led1,OUTPUT);
    pinMode(led2,OUTPUT);
     
   lcd.setCursor(0,0);
   lcd.print("Resistor Sorter");
   Serial.println("Resistor Sorter");
   delay(1000);
   
   lcd.clear();
   
   lcd.print("Pls give value:-");
   Serial.println("Pls set resistance..");
   delay(1000);
   
   lcd.clear();

   lcd.print("Resistance:-");
   Serial.println("Resistance:-");
   lcd.setCursor(0,1);
   while(true)
    {
      char key = keypad.getKey();
      num = key;
      
      if(num)
      {
        if (key != '#')
        {
          a = num - 48;
          b = b * 10;
          b = b + a;
          Serial.println(b);
        }
        if(key == '#')
        {
          Serial.println("ok");
          lcd.print(b);
          delay(1000);
          
          lcd.clear();
          
          lcd.print("OK");
          delay(500);
          
          lcd.clear();
          
          Serial.println(b);
          break;
        }
      }
    }
}



void loop(){
  
 // lcd.setCursor(0,0);
 // lcd.print("working...");
  
  M3.write(0);
  delay(10);
  digitalWrite(led1,HIGH);
  digitalWrite(led2,LOW);
  delay(1000);
  digitalWrite(led1,LOW);
  digitalWrite(led2,HIGH);
  
  M1.write(120);
  M2.write(160);
  delay(10);
  
  delay(1000);
  
  Serial.println("reading");
  
 v_in1 = analogRead(P1);
 V1 = v_in1 * (5.0/1023.0);
 Serial.print(V1); 
 Serial.print("v          ");

 v_in2 = analogRead(P2);
 V2 = v_in2 * (5.0/1023.0);
 Serial.print(V2); 
 Serial.print("v          ");

 v_out = V1 - V2;
 Serial.print(v_out);
 Serial.print("           ");
 
 I = v_out / R1;
 Serial.print(I,6);
 Serial.print("A          ");

 Rd = V2 / I;
 Serial.println(Rd);


      lcd.clear();
      lcd.setCursor(0,0);
      lcd.print(Rd);

  
  M1.write(70);
  M2.write(90);
  delay(10);
 
  delay(1000);
  lcd.clear();
  
    error = 0.2 * b;

    max_per = b + error;
    min_per = b - error;



    /*while(true)
    {
      Serial.print(max_per);
      Serial.print("   ");
      Serial.println(min_per);
      break;
    }*/

    lcd.clear();
    lcd.setCursor(0,0);
    lcd.print(max_per);
    lcd.setCursor(0,1);
    lcd.print(min_per);

    if(Rd <= max_per and Rd >= min_per)
    {
      lcd.clear();
      //Serial.println(Rd);
      lcd.print("found");
      M3.write(90);
      M4.write(30);
      delay(10);
     delay(1000);
    }
   else{
      
      M3.write(80);
      M4.write(150);
      delay(10);
      
      delay(1000);
      
    }
    
    M4.write(90);
    delay(10);
}
